unit vortex;
{
        TVortexIRC v1.6 Modified by Acryl ( See annotations marked with "Acryl" )

        http://vortex.berzerk.net

        IRC: joepezt @ undernet :  #Delphi #Kylix
        ICQ: 340148, 3941292
        Email: joepezt@c2i.net
               vortex@berzerk.net

        TVortexIRC is an OpenSource IRC component by joepezt@berzerk.net
        Feel free to use it on whatever you want, send me bug fixes & suggestions
        and or just help me develop it.

        if you plan to use it in your own application,
        please give me some credits...
        link to my homepage, and i also want a copy and test it :)
        thanx:)
        you might also put a "powered by Vortex" on your project ;)

        i would also like to have your projects posted on my page, eighter the
        whole compiled project and or a link to it. or even a small description
        of it.

        Stuff i want to implement in the first place:
        Action(/me), Mode stuff, kick, color stuff
        ISON, hostname in private message / channel

        if anyone of you find and fixes a bug, please send them back to me
        vortex@berzerk.net. just use "vortex" as subject

        Read the Lisence at: http://vortex.berzerk.net/gnu.txt

        29.09.2001
        + Command parser Removed.
        + Added Joined,Parted
        + kick, ban, op, deop, SetMode (user/channel), voice, DeVoice & Topic commands added!

        20.09.2001
        + To much to add
        + "raw" command is now "quote"
        + Modified by Acryl
        + Code optimizing, and cleanups..

        18.09.2001
        + Anthony Chatman fixed a MOTD bug.
        + misc Bugfixes...
        - There is an OnPart bug, i will look onto it later!

        29.08.2001
        + added Real DCC support (code could be optimized alot i think)
        + fixed bug in channel join (hostname/channelname)
        + added an array of string (0..10) for use of temporary variables.
        - Notice still got some bugs, havent time to fix it right now

        27.08.2001
        + Added Terror, BgException Courtesy of Jean.
        + Topic, Motd, Join part quit,Nick in use, names all added :)
        + Added more channel prefixes, optimized code,
          set linemode so we makesure we receive all lines :)
        + `Snake made a nice function to check if nickname is valid!

        07.08.2001
        + kylix support
          (installable, but not sure if it actually works!. let's try :)
        + added an experimental command parser
        + Between function from Wolfman :)

        10.07.2001
        + First public release!
        + IRC nick        + Username
        + RealName        + Autoreply ping
        + version reply   + server automated connection
        can connect via vortex1.server('ircserver.com','6667');
}

interface
 uses
 {$IFDEF WIN32}
  Classes, Controls, Windows, wsocket, SysUtils;
 {$ELSE} // Linux Kylix
  Classes, IcsSocket, SysUtils;
 {$ENDIF}


type
  TIRCEevents = class(Tobject)
  end;

  TStartEvent      = procedure of object;
  TDisconnectEvent = procedure of object;
  TConnectEvent    = procedure of object;
  TError           = Procedure (Sender : Tobject; Error : word) of object;
  TBGException     = Procedure (Sender : Tobject; E : Exception; Var CanClose : Boolean) of Object;
  TChannelMsg      = procedure (channelname,content,nick : string)  of object;
  TServerMsg       = procedure (command : string) of object;
  TCtcp            = procedure (from, command, dest : string) of object; // Acryl : Modified ( see DataReceive-Handler for explanation )
  TNotice          = procedure (nick, content : string) of object;
  TPrivMsg         = procedure (nickname,content : string) of object;
  TJoin            = procedure (nickname,hostname,channel : string) of object;
  TJoined          = procedure (channel : string) of object;
  TPart            = procedure (nickname,hostname,channel,reason : string) of object;
  TParted          = procedure (channel : string) of object;
  TNickChanged     = procedure (newnick : string) of object;
  TNickChange      = procedure (oldnick, newnick : string) of object;
  TQuit            = procedure (nickname,reason : string) of object;
  TMotd            = procedure (line : string) of object;
  TTopic           = procedure (channel,nick,Topic : string) of object;
  TNickInUse       = procedure (nick : string) of object;
  TNames           = procedure (commanicks, channel : string) of object;
  TAction          = procedure (from, content, dest : string) of Object; // Acryl : added
  TInvite          = procedure (from, channel : string) of ObjecT;       // Acryl : added
  TDCCFileRecv     = procedure (nickname,filename, FileSize, address, port : string) of object;
  TDCCChatRecv     = procedure (nickname, address, port : string) of object;

Type
  TVortexIRC = class(TComponent)
  private
    // Acryl : Debugging only
{    FDebugFile   : Text; }

    // Acryl : Moved em here
    FVersion     : String;
    FMyNick      : String;
    FUsername    : String;
    FAddr        : String;
    FPort        : string;
    FRealName    : String;
    FAutopong    : boolean;
    {$IFDEF WIN32}
    FClient      : Twsocket;
    //FSocket      : Twsocket;
    {$ELSE} // Linux Kylix
    FClient      : TIcsSocket;
    {$ENDIF}
    // Changed Names - user defined evcent handlers
    FChannelMsg  : TChannelMsg;
    FServerMsg   : TServerMsg;
    FCtcp        : TCtcp;
    FTopic       : TTopic;
    FNickjoin    : TJoin;
    FJoined      : TJoined;
    FDCCFileRecv : TDCCFileRecv;
    FDCCChatRecv : TDCCChatRecv;

    FError       : TError;
    FNotice      : TNotice;
    FNickPart    : TPart;
    FParted      : TParted;
    FNickChanged : TNickChanged;
    FNickChange  : TNickChange;
    FNickQuit    : TQuit;
    FNickInUse   : TNickInUse;
    FNames       : TNames;
    FPrivMsg     : TPrivMsg;
    FStart       : TStartEvent;   // initialisert
    FSocketClose : TDisconnectEvent;
    FConnect     : TConnectEvent;
    FBgException : TBGException;
    FMotd        : TMotd;
    FAction      : TAction;                                                             // Acryl : added
    FInvite      : TInvite;
  protected
    // Moved these here
    // Event handlers
    procedure OnSocketDataAvailable(Sender: TObject; Error: Word);
    procedure OnSocketClosed(Sender: TObject; Error: Word);
    procedure OnSocketConnected(Sender: TObject; Error: Word);
    procedure OnVortexIRCError (Sender: TObject);
    procedure OnVortexBgException(Sender: TObject; E: Exception;  var CanClose: Boolean);

  public
     FOnline      : boolean;
    // Constructor / Destructor
    constructor Create(AOwner : TComponent); override;
    destructor  Destroy(); override;
    procedure   Loaded(); override;

    // String Manipulation routines (Moved by Acryl)
    Function    RemoveCRLF(S : String; ReplaceWithWS : Boolean = True) : String;        // Acryl : Added
    Function    Split(position : integer; Line : string; delimiter : char) : String;
    Function    Between(S,Start,stop:string):string;
    Function    ScanNick( nick : string; MaxLen : Integer) : Boolean;                   // Acryl : Modified
    Function    LongIP(IP : string) : string;                                           // Acryl : Modified
    Function    ShortIP(const S: string): string;                                       // Acryl : Modified

    // Some helpers by Acryl ... Mask is always the param (format: Nickname!Ident@some.host.com)
    Function    GetNickFromMask(S : String)     : String;  // e.g. |Acryl|
    Function    GetHostmaskFromMask(S : String) : String;  // e.g. Acryl@Dubplates.org
    Function    GetIdentFromMask(S : String)    : String;  // e.g. Acryl
    Function    GetHostFromMask(S : String)     : String;  // e.g. Dubplates.org

    // user commands goes here...
    Procedure   initDCCchat(nick : string);
    Procedure   InitDCCSend(nick, filename, filesize : string);
    Procedure   Quote(command : string);
    Procedure   Say(destination, content : string);
    Procedure   join(channel,key : string);
    Procedure   Part(channel,reason : string);
    Procedure   Quit(reason : string);
    procedure   SetMode(Destination, Modes : string);
    procedure   Ban(nick, host, channel : string);
    procedure   Op(nick, channel : string);
    procedure   Deop(nick, channel : string);
    procedure   Voice(nick, channel : string);
    procedure   DeVoice(nick, channel : string);
    procedure   Kick(Victim, channel, Reason : string);
    procedure   Topic(channel, Topic : string);
    Procedure   Nick(newnick : string);
    Procedure   User(nick, user, ip, realname : string);
    Procedure   Server(server,port : string);
    Procedure   Disconnect(force : boolean; reason : string);
    Procedure   Notice(destination, content : string);
    Procedure   CTCPReply(nick, command : string);
    Procedure   connect;
    Function    LocalIP(num : byte) : string;                                           // Acryl : Modified
  published
    // Properties ...
    property ReplyToPing    : boolean       read FAutoPong   write FAutoPong;
    property IrcServer      : String        read FAddr       write FAddr;
    property IrcPort        : String        read FPort       write FPort;
    property IrcNick        : String        read FMyNick     write FMyNick;
    property IrcName        : String        read FRealname   write FRealname;
    property IrcUser        : String        read FUserName   write FUserName;
    property VersionReply   : string        read FVersion    write FVersion;
    // User-defined event handlers
    property OnChannelMsg   : TChannelmsg   read FChannelMsg write FChannelMsg;
    property OnPrivMsg      : TprivMsg      read FPrivMsg    write FPrivMsg;
    property OnJoin         : TJoin         read FNickJoin   write FNickjoin;
    property OnJoined       : TJoined       read FJoined     write Fjoined;
    property OnPart         : TPart         read FNickPart   write FNickPart;
    property OnParted       : TParted       read FParted     write FParted;
    property OnTopic        : Ttopic        read FTopic      write FTopic;
    property OnNotice       : TNotice       read FNotice     write Fnotice;
    property OnQuit         : TQuit         read FNickQuit   write FNickQuit;
    property OnServer       : TServerMsg    read FServerMsg  write FServerMsg;
    property OnCtcp         : Tctcp         read FCtcp       write FCtcp;
    property OnNames        : Tnames        read FNames      write FNames;
    property OnNickInUse    : TNickInUse    read FNickInUse  write FNickInUse;
    property OnNickChange   : TNickChange   read FNickChange write FNickChange;
    property OnNickChanged  : TNickChanged  read FNickChanged write FNickChanged;
    property OnMOTD         : Tmotd         read FMotd       write FMotd;
    property OnDCCChat      : TDCCChatRecv  read FDCCChatRecv write FDCCChatRecv;
    property OnDCCFileReceive : TDCCFileRecv read FDCCFileRecv write FDCCFileRecv;
    property OnStarted      : TStartEvent   read FStart      write FStart;
    property OnAction       : TAction       read FAction     write FAction;             // Acryl : added
    property OnInvite       : TInvite       read FInvite     write FInvite;             // Acryl : added

    //Socket related stuff
    property OnDisconnect   : TDisconnectEvent Read FSocketClose write FSocketClose;
    property OnConnect      : TConnectEvent    Read FConnect     write FConnect;
    Property OnError        : Terror           Read FError       write FError;
    Property OnBgException  : TBgException     Read FBGException write FBGException;
end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('joepezT', [TVortexIRC]);
end;

//-------------------------------------------------------------------
// Misc constants
//-------------------------------------------------------------------

const     MWG_VERSION_MAJOR     = '0';
          MWG_VERSION_MINOR     = '1';
          MWG_VERSION_TAG       = '-BETA-';
          MWG_VERSION_TAG_SHORT = '-B-';

//-------------------------------------------------------------------
// Constructor / Destructor
//-------------------------------------------------------------------

Constructor TVortexIRC.Create(AOwner: TComponent);
Begin
        Inherited Create(Aowner);
        FVersion      := 'Vortex - v' + MWG_VERSION_MAJOR + '.' + MWG_VERSION_MINOR + ' ' + MWG_VERSION_TAG;
        FRealname     := 'IRC Component';
        FUsername     := 'Vortex';
        FAddr         := 'eu.undernet.org';
        FPort         := '6667';
        FMyNick       := 'Vortex' + inttostr(random(999));

        // The following objects only needed during run-time.
        If NOT (csDesigning in ComponentState) Then
        Begin
        {$IFDEF WIN32}
        FClient := TWSocket.Create(Self);
        FClient.Name := 'Client' + inttostr(FClient.handle);
        {$ELSE} // Linux Kylix
        FClient := TIcsSocket.Create(Self);
        FClient.Name := 'Client' + inttostr(random(65535));
        {$ENDIF}
                With FClient do
                Begin
                        OnDataAvailable := OnSocketDataAvailable;
                        OnSessionClosed := OnSocketClosed;
                        OnError         := OnVortexIRCError;
                        OnBgException   := OnVortexBgException;
                        OnSessionConnected := OnSocketConnected;
                        LineEdit := False;
                        LineEcho := False;
                        LineEnd  := #13#10;
                        LineMode := True;
                        Port  := '6667';
                        Proto := 'tcp';
                        Addr  := '127.0.0.1';
                End;
        End;
End;

Destructor TVortexIRC.Destroy();
Begin
        If NOT (csDesigning in ComponentState) Then
        Begin
                FClient.Free();
        End;
        Inherited Destroy();
End;

Procedure TVortexIRC.Loaded();
Begin
        Inherited Loaded();
        If NOT (csDesigning in ComponentState) Then
        Begin
                If Assigned(FStart) Then FStart();
        End;
End;

//-------------------------------------------------------------------
// String manipulation functions
//-------------------------------------------------------------------

// By Acryl
Function  TVortexIRC.RemoveCRLF(S : String; ReplaceWithWS : Boolean) : String;
Var       LastWasWS  : Boolean;
          Tmp_String : String;
          Count      : Integer;
Begin
        // Quick exit condition
        If (Length(S) = 0) Then
        Begin
                Result := '';
                exit;
        End;

        // We set these after the quick exit to spare some cycles if quick-exit was met
        Tmp_String := '';
        LastWasWS  := FALSE;

        For Count:=1 To Length(S) Do
        Begin
                If ((S[Count] = #10) OR (S[Count] = #13)) Then
                Begin
                        If (ReplaceWithWS AND (NOT LastWasWS)) Then
                        Begin
                                LastWasWS := True;
                                Tmp_String := Tmp_String + ' ';
                                Continue;
                        End;
                End;
                If (S[Count] = ' ') Then
                        LastWasWS := True
                Else
                        LastWasWS := False;

                Tmp_String := Tmp_String + S[Count];
        End;
        Result := Tmp_String;
End;

Function TVortexIRC.Split(position : integer; Line : string; delimiter : char) : string;
Var      X,Y        : Integer;
         Tmp_String : String;
Begin
        Tmp_String := '';
        Y := 1;

        For X:=1 To Length(line) Do
        Begin
                If (y >= position) Then
                        Tmp_string := tmp_string + line[x];

                If (line[x] = delimiter) Then
                        Inc (y);
        End;
        Result := tmp_string;
End;

// Great string manipulation which i got from Wolfman :)
Function TvortexIRC.Between(S,Start,stop:string):string;
Var      P1,P2:integer;
Begin
     P1:=Pos(start,s);
     P2:=pos(stop,s);
     Result:=copy(s,p1+1,p2-p1-1);
End;

// check if a nickname is valid
// sent in by snake`
// Acryl : Modified it so that you can pass a max nicklen - 0 = no limit
Function TvortexIRC.ScanNick(nick : string; MaxLen : Integer) : Boolean;
const    ValidChars : set of Char = ['0'..'9','A'..'Z','a'..'z','[',']','|','{','}','-','_','`','^'];
var      X    : Integer;
Begin
        Result:=false;

        // Quick exit 1
        IF (Length(Nick) = 0) Then
                Exit;

        // Quick exit 2
        If ((MaxLen > 0) AND (Length(Nick) > MaxLen)) Then
                Exit;

        X := 1;
        While (x <= Length(Nick)) Do
        Begin
                If (Nick[X] in ValidChars) Then
                        Inc(X)
                Else
                        Exit;
        end;

        // A nickname mustn't begin with a number
        if ( (ord(Nick[1]) >= ord('0')) AND (ord(Nick[1]) <= ord('9'))) Then
                Exit;

        Result := True;

end;

//ShortIP
// Example: 3232235777 -> 192.168.1.1
// Acryl : Modified
Function TvortexIRC.shortIP(const S: string): string;
Var      IP         : int64;
         A, B, C, D : Byte;
Begin
        IP := StrToInt64(S); // wtf -> Wrooong: StrToInt64 .. Ip addy is 32Bit
        A  := (IP AND $FF000000) SHR 24;
        B  := (IP AND $00FF0000) SHR 16;
        C  := (IP AND $0000FF00) SHR 8;
        D  := (IP AND $000000FF);
        Result := Format('%d.%d.%d.%d', [A, B, C, D]);
End;

//Long IP
// Acryl : Modified
// Example: 192.168.1.1 -> 3232235777
// used in DCC routines...
Function TvortexIRC.LongIP(IP : String) : String;
Var      IPaddr   : array[1..4] of Word;
         Temp     : string;
         Res      : DWord;
         I        : integer;

Begin
        Temp := IP + '.';
        For I:=1 To 4 Do
        Begin
                Try
                        IPaddr[i] := strtoint(copy(Temp,1,pos('.',Temp) - 1));
                        Delete(temp,1,pos('.',Temp));

                        If (IPaddr[i] > 255) Then
                                raise Exception.Create('');
                Except
                       // Check the IP
                       result := 'Invalid IP address.';
                       Exit;
                End;
        End;

        Res := (ipaddr[1] SHL 24) + ipaddr[1] +
               (ipaddr[2] SHL 16) + ipaddr[2] +
               (ipaddr[3] SHL 8)  + ipaddr[3] +
               (ipaddr[4]);
        Result := Format('%u',[res]);
End;

//-------------------------------------------------------------------
// Command parsers by Acryl
//-------------------------------------------------------------------
function  TVortexIRC.GetNickFromMask(S : String) : String;
Var       C       : Integer;
          TmpString : String;
Begin
        S := Trim(S);
        If (Length(S) = 0) Then
                Exit;

        TmpString := '';

        For C:=1 To Length(S) Do
        Begin
                If (S[C] = '!') Then
                        break;

                TmpString := TmpString + S[C];
        End;
        Result := TmpString;
end;

function  TVortexIRC.GetIdentFromMask(S : String) : String;
Var       C       : Integer;
          Copying : Boolean;
          TmpString : String;
Begin
        S := Trim(S);
        If (Length(S) = 0) Then
                Exit;

        TmpString := '';
        Copying    := False;

        For C:=1 To Length(S) Do
        Begin
                If (S[C] = '@') Then
                        break;

                If (S[C] = '!') Then
                        Copying := True
                else If (Copying) Then
                        TmpString := TmpString + S[C];
        End;
        Result := TmpString;
end;

function  TVortexIRC.GetHostFromMask(S : String) : String;
Var       C       : Integer;
          Copying : Boolean;
          TmpString : String;
Begin
        S := Trim(S);
        If (Length(S) = 0) Then
                Exit;

        TmpString := '';
        Copying    := False;

        For C:=1 To Length(S) Do
        Begin
                If (S[C] = '@') Then
                        Copying := True
                else If (Copying) Then
                        TmpString := TmpString + S[C];
        End;
        Result := TmpString;
end;

function  TVortexIRC.GetHostmaskFromMask(S : String) : String;
Var       C       : Integer;
          Copying : Boolean;
          TmpString : String;
Begin
        S := Trim(S);
        If (Length(S) = 0) Then
                Exit;

        TmpString := '';
        Copying    := False;

        For C:=1 To Length(S) Do
        Begin
                If (S[C] = '!') Then
                        Copying := True
                else If (Copying) Then
                        TmpString := TmpString + S[C];
        End;
        Result := TmpString;
end;


//-------------------------------------------------------------------
// User commands
//-------------------------------------------------------------------
Procedure TVortexIRC.Quote(command : string);
Begin
        FClient.sendstr(command + #10#13);
End;

Procedure TVortexIRC.Say(destination, content : string);
Begin
        Quote(format('PRIVMSG %s :%s',[destination,content]));
End;

procedure TVortexIRC.notice(destination, content : string);
begin
        Quote(format('NOTICE %s :%s',[destination,content]));
end;

procedure TVortexIRC.SetMode(Destination, Modes : string);
begin
        Quote(format('MODE %s %s',[Destination,modes]));
end;

procedure TVortexIRC.Ban(nick, host, channel : string);
var
mask : string;

begin
        mask := '*' + nick + '*!*@' + host;
        Quote(format('MODE %s +b %s',[channel,mask]));
end;

procedure TVortexIRC.Op(nick, channel : string);
begin
        Quote(format('MODE %s +oooo %s',[channel,nick]));
end;

procedure TVortexIRC.Deop(nick, channel : string);
begin
        Quote(format('MODE %s -oooo %s',[channel,nick]));
end;

procedure TVortexIRC.Voice(nick, channel : string);
begin
        Quote(format('MODE %s +vvvv %s',[channel,nick]));
end;

procedure TVortexIRC.DeVoice(nick, channel : string);
begin
        Quote(format('MODE %s -vvvv %s',[channel,nick]));
end;

procedure TvortexIRC.Topic(channel, Topic : string);
begin
        Quote(format('TOPIC %s :%s',[channel,Topic]));
end;

procedure TVortexIRC.Kick(Victim, channel, Reason : string);
begin
        Quote(format('KICK %s %s :%s',[channel,victim,reason]));
end;

Procedure TVortexIRC.join(channel,key : string);
begin
        if key <> '' then
           Quote(format('Join %s',[channel]))
           else
           Quote(format('Join %s :%s',[channel,key]))
end;

Procedure TVortexIRC.connect;
begin
        Fclient.connect;
end;

Procedure TVortexIRC.InitDCCchat(nick : string);
var
port : string;

begin
        // this is not finished, i need to know how to allocate the next free port
        port := '123456';
        Quote(format('PRIVMSG %s :' + #1 + 'DCC CHAT chat %s %s' + #1,[nick,longip(localip(0)),port]));
end;

Procedure TvortexIRC.InitDCCsend(nick, filename, filesize : string);
var
port : string;

begin
        // this is not finished, i need to know how to allocate the next free port
        port := '123456';
        Quote(format('PRIVMSG %s : '+ #1 + 'DCC SEND %s %s %s' + #1,[nick,filename, longip(localip(0)), filesize, port]));
end;

procedure TVortexIRC.Part(channel,reason : string);
begin
if reason <> '' then
        Quote(format('part %s :%s',[channel,reason]))
        else Quote(format('part %s',[channel]))
end;

procedure TVortexIRC.Quit(reason : string);
Begin
        If (trim(Reason) = '') Then
           Reason := 'powered by VorteX IRC'; // change it to whatever you want
        Quote(format('QUIT :%s',[reason]));
End;

Procedure TVortexIRC.CTCPReply(nick, command : string);
Begin
        Quote(format('NOTICE %s :%s%s%s',[nick,#1,command,#1]));
End;

Procedure TVortexIRC.Disconnect(force : boolean; reason : string);
Begin
        If (NOT force) Then
                Quit(reason)
        Else
                FClient.close();
        FOnline := False;
End;

Procedure TVortexIRC.Nick(newnick : string);
Begin
        // TODO: fixit
        // check if the nickname is valid and if it is, send it to the server
        //if ScanNick(newnick, false) <> false then
        //if  isCharAlphNumeric
        Quote(format('NICK %s',[newnick]))
End;

Procedure TVortexIRC.Server(server,port : string);
Begin
        // connect to IRC, or reconnect...
        If (FOnline) Then
                Quit('Vortex - Changing server.');
        Sleep(200);
        FClient.Addr := Server;
        FClient.Port := Port;
        FClient.Connect();
End;

procedure TVortexIRC.User(nick, user, ip, realname : string);
begin
        // Used only during authentication
        Quote(format('USER %s %s %s :%s',[nick,user,ip,realname]));
end;


// Format of Standart Messages:
//  :From MessageType To :Parameters
//      From can either be:
//              Server.host.address
//      Or:
//              Nickname!ident@host.mask.com
// Some special messages:
//  NOTICE Constant/To :Message
//      Constant is e.g. AUTH
//  PING :From
//      From is server.address.com
// CTCPS are sent as privmsgs delimited by #1 at beginning & end
//
// Sometimes Messages got the following format:
// :From MessageType To SomethingElseHere :Parameters
// If this is the case "SomethingElseHere" will be stroed in cmdMiddle

Procedure TVortexIRC.OnSocketDataAvailable(Sender: TObject; Error: Word);
Var       Received  : string;
          Backup    : String;
          Channel   : string;
          Temp      : string;
          Params    : Array[0..10] Of String;  // just extra parameters, used for temporary strings
          I         : Integer;

          CmdFrom      : String;   // Who sent us this command ?
          CmdName      : String;   // What command is it ?
          CmdTo        : String;   // To whom does this go - irgnored most of the time
          CmdMiddle    : String;   // Possible Middle string;
          CmdAllParams : String;   // Everything past :
Begin
        // i dont know why i do this, but i allways found it usefull...
        Received := FClient.ReceiveStr();
        Backup   := Received;

        // Set the variables to thier initial state
        CmdFrom      := '';
        CmdName      := '';
        CmdTo        := '';
        CmdMiddle    := '';
        CmdAllParams := '';

        // First of all remove all trailing CRLFs and Whitespaces
        Received := TrimRight(Received);

        // Quick exit - unlikely but possible still
        If (Length(Received) = 0) Then
                exit;

        // If From is specified ...
        If (Received[1] = ':') Then
        Begin
                // Cmd:     :From.Here Command .....
                I := Pos(' ', Received);
                If (I > 2) Then
                        CmdFrom := Copy(Received,2,I-2);
                Delete(Received,1,I);
        End;

        // Now get the command name
        Begin
                I := Pos(' ', Received);
                If (I > 1) Then
                        CmdName := Copy(Received,1,I-1);
                Delete(Received,1,I);
        ENd;

        // Now check if there is an additional constant or "to"
        If (Received[1] <> ':') Then
        Begin
                I := Pos(' ', Received);
                If (I > 1) Then
                        CmdTo := Copy(Received,1,I-1);
                Delete(Received,1,I);
        End;

        // Now check if there is an additional middle-string
        If (Received[1] <> ':') Then
        Begin
                I := Pos(' ', Received);
                If (I > 1) Then
                        CmdMiddle := Copy(Received,1,I-1);
                Delete(Received,1,I);
        End;

        // Now the get the rest with out the ":"
        If (Length(Received) > 1) Then
                If (Received[1] = ':') Then
                        CmdAllParams := Copy(Received,2,Length(Received)-1)
                Else
                        CmdAllParams := Received;

        // Now restore it - duinno yet if I need it
        Received := TrimRight(Backup); // Again - remove trailing whitespace

        // For Debugging ONLY
{        Writeln(FDebugFile, Received);
        Writeln(FDebugFile, 'CmdFrom:      ',cmdFrom);
        Writeln(FDebugFile, 'CmdName:      ',cmdName);
        Writeln(FDebugFile, 'CmdTo:        ',cmdTo);
        Writeln(FDebugFile, 'CmdMiddle:    ',cmdMiddle);
        Writeln(FDebugFile, 'CmdAllParams: ',cmdAllParams);
        Writeln(FDebugFile); }

        // Trigger server (dataavailable / any data)
        If Assigned(FServerMsg) then
                FServerMsg(Received);

        // Reply to Server Pings, to avoid disconnection
        If (uppercase(cmdName) = 'PING') Then
        Begin
                Quote('PONG ' + cmdAllParams);
                Exit;   // We're done
        end;


        // User Joining, (this includes me as well) TODO: Make seperate event for that
        // (nickname host channel)
        If (uppercase(cmdName) = 'JOIN') Then
        Begin
        // Check wether this is me or others
        if GetNickFromMask(cmdFrom) <> Fmynick then 
           If Assigned(FNickJoin) Then
              begin
                FNickJoin(GetNickFromMask(cmdFrom),GetHostmaskFromMask(cmdFrom),cmdAllParams);
                exit;
              end;
           If Assigned(FJoined) Then
                       FJoined(cmdAllParams);
           Exit;   // We're done
        end;

        // User parting (this includes me as well)
        // (nickname host channel reason)
        If (uppercase(cmdName) = 'PART') Then
        Begin
             I := Pos(' ',cmdAllParams);
             If (I = 0) Then
                        I := Length(cmdAllParams) + 1;
                             Channel := Copy(cmdAllParams,1,I-1);
                             Delete(cmdAllParams,1,I-1);

          if GetNickFromMask(cmdFrom) <> FMyNick then // this is not me
                If Assigned(FNickPart) Then
                Begin
                        FNickPart(GetNickFromMask(cmdFrom),    //nickname
                                  GetHostFromMask(cmdFrom),    //grab hostname (not username)
                                  channel,                     //get channelname
                                  cmdAllParams);                //part reason
                exit;
                End;
                If Assigned(FParted) Then
                        FParted(channel);
                Exit;
        End;

        // User quitting
        // (nickname reason)
        If (uppercase(cmdName) = 'QUIT') Then
        Begin
                If Assigned(FNickQuit) Then
                        FNickQuit(GetNickFromMask(cmdFrom), cmdAllParams);
                Exit;
        end;

        //Motd stuff
        If (cmdName = '372') Then
        Begin
                If Assigned(FMotd) Then
                        FMotd(cmdAllParams);
                Exit;
        End;

        // End of /Motd command
        If (cmdName = '376') Then
        Begin
                If Assigned(FMotd) Then
                        FMotd(cmdAllParams);
                Exit;
        End;

        // who stuff
        If (cmdName = '352') Then
        Begin
                Exit;
        End;

        // end of /who
        If (cmdName = '315') Then
        Begin
                Exit;
        End;

        //Nick already in use
        //:irc.server.com 433 * OldNickName :Description
        If (cmdName = '433') Then
        Begin
                If Assigned(FNickInUse) Then
                        FNickInUse(cmdMiddle);
                Exit;
        End;

        // Ison
        If (cmdName = '303') Then
        // 461 - :irc.homelien.no 461 joepz ISON :Not enough parameters
        Begin
                exit;
        End;

        //Topic when joining a channel
        //:irc.server.com 332 To Channel :Topic
        If (cmdName = '332') Then
        Begin
                If Assigned(FTopic) Then
                        FTopic(cmdMiddle,'The nick is unavailable',cmdAllParams);
                Exit;
        end;

        // SOmeone changed the topic
        //:Nick!ident@host.com TOPIC Channel :NewTopic
        If (uppercase(cmdName) = 'TOPIC') Then
        Begin
                If Assigned(FTopic) Then
                        FTopic(cmdTo,GetNickFromMask(cmdFrom),cmdAllparams);
                Exit;
        End;

        // Nick name list
        // :irc.server.com 353 To = Channel :SpaceSperatedNickList (@ and + prefixes are included)
        //                        ^---- What a fucking bad way to pass the names bleh
        If (cmdName = '353') Then
        Begin
                If Assigned(FNames) Then
                Begin
                        Temp    := cmdAllParams;
                        Channel := Copy(Temp,1,Pos(':',Temp)-2);
                        Delete(Temp,1, Pos(':',Temp));

                        // Replace spaces with commatas
                        If (Length(Temp) > 0) Then
                           For I:=1 To Length(Temp) Do
                                If (Temp[I] = ' ') Then
                                        Temp[I] := ',';

                        FNames(temp,channel);
                End;
                Exit;
        End;

        // end of /names
        If (cmdName = '366') Then
        Begin
                Exit;
        End;


        // There are 2 different types of NOTICEs:
        //      1. NOTICE Constant :SomeTextHere                (coming from server)
        //      2. :Nick!ident@host.com NOTICE To :SomeTextHere (coming from user 'nick')
        If (uppercase(cmdName) = 'NOTICE') Then
        Begin
                If Assigned(FNotice) Then
                Begin
                        If (cmdFrom <> '') Then
                                FNotice(GetNickFromMask(cmdFrom),cmdAllParams)
                        Else
                                FNotice('',cmdAllParams);
                end;
                Exit;
        End;

        // Invites
        //:Nick!Ident@host.com INVITE MyNick :Channel
        If (uppercase(cmdName) = 'INVITE') Then
        Begin
                If Assigned(FInvite) Then
                        FInvite(GetNickFromMask(cmdFrom),cmdAllParams);
                Exit;
        End;

        If (uppercase(cmdName) = 'NICK') Then
        Begin
        // check if this is me who changed nick!
        if GetNickFromMask(cmdFrom) <> Fmynick then
        If Assigned(FNickChange) Then
                begin
                        FNickChange(GetNickFromMask(GetNickFromMask(cmdFrom)),CmdAllParams);
                        exit;
                end;

        If Assigned(FNickChanged) Then
                    FNickChanged(cmdAllParams);
                    FMynick := CmdAllParams;
                    Exit;
        End;

        // Again there are different types of PRIVMSGs:
        // :Nick!ident@host.com PRIVMSG To :SomeTextHere
        //      Now "To" can either be your current Nick, then it's aprivate message
        //      or a channel name then it's a channel message.
        //      If The PRIVMSG was a CTCP then "SomeTextHere" begins and ends with char #1.
        //      Again CTCPs can be sent to individuals or to channels
        //      Some CTCPs have a really stupid formatting sicne they append the Nick of
        //      after the trailing #1
        //      In this case we can safely ignore "NicknameItComesFrom" sicne it's alos passed
        //      as :Nick!ident@...
        If (UpperCase(cmdName) = 'PRIVMSG') Then
        Begin
                // Just to be safe
                If (Length(cmdAllParams) = 0) Then
                        Exit;

                // Is it a CTCP-Message ?
                // Can be optimized ... too much copying for my taste
                // I changed the CTCP-event handler.
                // A third parameter "Dest" was added so that the user-assigned event-handler
                // can destinguish between CTCPs sent directly to the user and
                // CTCPs sent to a whole channel.
                If (cmdAllParams[1] = #1) Then
                Begin
                        // Strip of the leading #10 char and the trailing
                        // #10 char including everything that comes behind it
                        Delete(cmdAllParams,1,1);
                        If (Length(cmdAllParams) > 0) Then
                        Begin
                                I:=Pos(#1,cmdAllParams);
                                If (I = 0) Then
                                        I := Length(cmdAllParams) + 1;
                                cmdAllParams := Copy(cmdAllParams,1,I-1);
                        End;

                        //Check if it's a dcc
                        If ((Length(cmdAllParams) > 3) AND (UpperCase(Copy(cmdAllParams,1,3)) = 'DCC')) Then
                        Begin
                        temp := CmdAllParams;

                        // Handle DCCs Here
                        params[10] := between(received,':','!');
                        for i := 0 to 9 do
                        begin
                          params[i] := copy(temp,1,pos(' ',temp));
                          params[i] := trim(params[i]);
                          delete(temp,1,pos(' ',temp));
                        end;

                        // when receiving a DCC chat request
                        if lowercase(params[1]) = 'chat' then
                        begin
                           // DCC CHAT chat ip (temp = port)
                           if assigned(FDCCChatRecv) then
                                FDCCChatRecv(params[10],shortip(params[3]),temp);
                                exit;
                        end;

                        // when receiving a DCC file transfer request
                        if lowercase(params[1]) = 'send' then
                        begin
                           // dcc send filename (temp = size) ip port
                           if assigned(FDCCFileRecv) then
                              FDCCFileRecv(params[10],params[2],temp,shortip(params[3]),params[4]);
                              Exit;
                        end;
                        End;

                        //Check if it's an action
                        If ((Length(cmdAllParams) > 6) AND (UpperCase(Copy(cmdAllParams,1,6)) = 'ACTION')) Then
                        Begin
                                If Assigned(FAction) Then
                                        FAction(GetNickFromMask(cmdFrom),Copy(cmdAllParams,7,Length(cmdAllParams)-7),cmdTo);
                                Exit;
                        End;

                        // Ok it's *no* DCC request and *no* Action -> fire a CTCP event
                        // The only *standart* CTCP we handle here is PING - this is required by the standart
                        // Everything else should be handled by the user-assigned eventhandler imho
                        // The CTCP event will still be fired though - since clients wnat to rect on this event
                        If ((Length(cmdAllParams) > 4) AND (UpperCase(Copy(cmdAllParams,1,4)) = 'PING')) Then
                                CTCPReply(GetNickFromMask(cmdFrom),cmdAllParams);
                        // Now fire the CTCP-event handler
                        If Assigned(FCTCP) Then
                        FCTCP(GetNickFromMask(cmdFrom),cmdAllParams, cmdTo);

                        Exit;
                End;

                // Is this a channel message ?
                if (pos('#',cmdTo) = 1) Then
                Begin
                        If Assigned(FChannelMsg) Then
                                FChannelMsg(cmdTo, cmdAllParams, GetNickFromMask(cmdFrom));
                        Exit;
                End;

                // Ok this must be a private Message
                // Finnally Trigger Private message!
                if Assigned(FPrivMsg) then
                        FPrivMsg(GetNickFromMask(cmdFrom), cmdAllParams);
                Exit;
        End;
End;

Procedure TVortexIRC.OnVortexIRCError (Sender: TObject);
Var       Error : word;
Begin
        Error := FClient.LastError;
        If Assigned(OnError) Then
                OnError(sender,error);
End;

Procedure TVortexIRC.OnVortexBgException(Sender: TObject; E: Exception;  var CanClose: Boolean);
Begin
        If Assigned(FBgException) Then
                FBgException(sender,E,Canclose);
End;

Procedure TVortexIRC.OnSocketClosed (Sender: TObject; Error: Word);
Begin
        FOnline := False;
        If Assigned(FSocketClose) Then
                FSocketClose();
        // For Debugging ONLY
        {CloseFile(FDebugFile);}
End;

Procedure TVortexIRC.OnSocketConnected (Sender: TObject; Error: Word);
Begin
        FOnline := True;
        // Sometimes this wont work, but no problem as long as the line is "clean"
        Nick(FMyNick);
        Sleep(50);
        User(FMyNick, FUserName, '0', FRealName);
        If Assigned(FConnect) Then
                FConnect();
        // For Debugging ONLY
{        AssignFile(FDebugFile,'C:\irclog.txt');
        Rewrite(FDebugFile);}
End;


// Acryl : Modified
Function TVortexIRC.LocalIP(num : byte) : String;
Begin
 {$IFDEF WIN32}
        Try
                Result := LocalIpList[num];
        Except
                Try
                        Result := LocalIpList[0];
                Except
                        // Result := LocalIpList[0]; // wtf ?!?
                        MessageBox(findwindow(nil,'explorer'),'No IP!','error.',mb_ok);
                End;
        End;
  {$ELSE} // Linux Kylix
   result := '127.0.0.1';
  {$ENDIF}
End;

End.


